Module gengeo :: Class InsertGenerator3D

[hide private]
[frames] | no frames]

# Class InsertGenerator3D

     object --+
              |
    ??.instance --+
                  |
       AGenerator3D --+
                      |
                     InsertGenerator3D

Known Subclasses:
  - HexAggregateInsertGenerator3D

A particle packing algorithm for filling AVolume3D spaces.

Instance Methods | [hide private]

void

__init__(...) Initialises a particle packer in preparation for filling an AVolume3D with particles whose radii are in the specified range. |

__str__(...) str(x) |

void

generatePacking(...) Generates a particle assembly to fill the specified volume. |

generatePackingMaxVolume(...) Fills the specified AVolume3D with particles until the accumulated particle volume exceeds the specified `maxVolume`. |

setNextTag(...) Sets tag for the next particles generated |

setOldSeeding(...) Sets seeding behavior to older method. |

Inherited from `AGenerator3D`: `__reduce__` Inherited from `unreachable.instance`: `__new__` Inherited from `object`: `__delattr__`, `__format__`, `__getattribute__`, `__hash__`, `__reduce_ex__`, `__repr__`, `__setattr__`, `__sizeof__`, `__subclasshook__`

Class Variables | [hide private]

| __instance_size__ = `60`

Properties | [hide private]

Inherited from `object`: `__class__`

Method Details | [hide private]

### __init__(...)
(Constructor)

Initialises a particle packer in preparation for filling an AVolume3D with particles whose radii are in the specified range. The packing will terminate after the specified number of insertion failures. The iterative solver will compute only the specified maximum number of iterations. Particles are permitted to overlap by the specified tolerance.

Parameters:
  - `minRadius` (double) - the minimum radius of particles to pack
  - `maxRadius` (double) - the maximum radius of particles to pack
  - `insertFails` (int) - the number of particle insertion failures before the packer terminates
  - `maxIterations` (int) - the maximum number of iterations of the solver
  - `tolerance` (double) - the overlap tolerance permitted
  - `seed` (bool) - randomize the random number generator if True (optional)
Returns: void
Overrides: object.__init__

### __str__(...)
(Informal representation operator)

str(x)

Overrides: object.__str__
  (inherited documentation)

### generatePacking(...)

Generates a particle assembly to fill the specified volume.

Parameters:
  - `volume` (AVolume3D) - the volume to fill with particles
  - `ntable` (MNTable3D) - the neighbours table that particles are inserted into
  - `groupID` (int) - the group ID assigned to particles (default: 0)
  - `tag` (int) - the tag assigned to the generated particles (optional (default: -1) if not followed by `ShapeList`)
  - `shapeList` (ShapeList) - the list of shapes to be inserted (optional)
Returns: void

### generatePackingMaxVolume(...)

Fills the specified AVolume3D with particles until the accumulated particle volume exceeds the specified `maxVolume`.

Parameters:
  - `maxVolume` (float) - the maximum cumulative volume of the inserted particles

### setNextTag(...)

Sets tag for the next particles generated

Parameters:
  - `tag` (int) - tag to assign the next particles generated by the InsertGenerator3D

### setOldSeeding(...)

Sets seeding behavior to older method.

Parameters:
  - `old` (bool) - toggle between old and new seeding methods.